{*******************************************}
{                                           }
{            FastReport v2.2                }
{          Objet complmentaire             }
{       Memo avec cadre arrondi et ombr    }
{                                           }
{ FastReport :(c) 1998-99 by Tzyganenko A.  }
{ RoundRect  : Guilbaud Olivier             }
{                golivier@worldnet.fr       }
{ Merci de transmettre vos commantaires     }
{                                           }
{Ce composant est un FREEWARE               }
{*******************************************}
{Histo :                                    }
{ 29/04/99 : Cration                       }
{ 30/04/99 : Corrections minueurs
             Changer le TButton en TImage
             pour le choix de la couleur
             de l'ombre.
             Initialis avec mots entiers
             par defaut                     }
{ 22/06/99 : Ajout la possibilit de dgrad
             mais dans ce cas, c'est un rectangle}

{WARNING FOR ENGLISH USER :
  Add this few lines in your FR.LNG file for translate
  the property editor :

[RoundRectForm]
Caption=Property editor
lblSample.Caption=Sample :
Button5.Caption=Variables ...
Button6.Caption=Data ..
bOk.Caption=OK
bCancel.Caption=Cancel
cbGradian.Caption=Gradian
lblSWidth.Caption=Shadow width
lblSColor.Caption=Color
cmShadow.Caption=Curve
cbCadre.Caption=Framed zone 
Label1.Caption=End Color
Label2.Caption=Begin color
Label3.Caption=Style
cbStyle.Items = Vertical | Horizontal |Elliptic|Rectangle |Horiz. Center |Vert. Center

}
unit FR_RRect;

interface

{$I FR_Vers.inc}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  FR_Class, StdCtrls, ExtCtrls, ClipBrd {$IFDEF Delphi4}, ImgList {$ENDIF},
  FR_Utils;


type
  {These are the six different gradient styles available.}
  TGradientStyle = (gsHorizontal, gsVertical, gsElliptic, gsRectangle,
                    gsVertCenter, gsHorizCenter);

  TfrRoundRectObject = class(TComponent)  // fake component
                       end;

  // Pour enregistrer les paramtres
  TfrRoundRect = packed record
                   SdColor: TColor;
                   wShadow: Integer;
                   Cadre  : Boolean;
                   sCurve : Boolean;
                   wCurve : Integer;
                 end;

  TfrRoundRectView = class(TfrMemoView)
  public
    Cadre : TfrRoundRect;
    constructor Create; override;
    procedure Assign(From:TfrView); override;
    procedure LoadFromStream(Stream:TStream); override;
    procedure SaveToStream(Stream:TStream); override;
    procedure CalcGaps; override;
    procedure ShowFrame; override;
    procedure ShowBackGround; override;
  end;

  // Editeur de proprits
  TRoundRectForm = class(TfrObjEditorForm)
    M1: TMemo;
    Button5: TButton;
    Button6: TButton;
    lblSample: TLabel;
    colorDlg: TColorDialog;
    bOk: TButton;
    bCancel: TButton;
    Image1: TImage;
    imgSample: TImage;
    cbGradian: TCheckBox;
    panCurve: TPanel;
    cmShadow: TCheckBox;
    sCurve: TEdit;
    lblSWidth: TLabel;
    ShWidth: TEdit;
    lblSColor: TLabel;
    bcolor: TImage;
    cbCadre: TCheckBox;
    panGrad: TPanel;
    Label1: TLabel;
    bcolor3: TImage;
    Label2: TLabel;
    bColor2: TImage;
    cbStyle: TComboBox;
    Label3: TLabel;
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure bColorClick(Sender: TObject);
    procedure ShWidthChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cbCadreClick(Sender: TObject);
    procedure cmShadowClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure M1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cbGradianClick(Sender: TObject);
  private
    { Dclarations prives }
    ShadowColor : TColor;
    NormalColor : TColor;

    procedure ChgColorButton(S : TObject; C : TColor);
    procedure UpdateSample;
  public
    { Dclarations publiques }
    procedure ShowEditor(t:TfrView); override;
  end;

Procedure Register;

implementation
uses FR_Var, FR_Flds;
{$R *.DFM}
{$R *.DCR}

var
  RoundRectForm: TRoundRectForm;

procedure PaintGrad(Cv : TCanvas; X,Y,X1,Y1 : Word; FBeginClr,FEndClr : TColor; FGradientStyle : TGradientStyle );
var
  FromR, FromG, FromB : Integer; //These are the separate color values for RGB
  DiffR, DiffG, DiffB : Integer; // of color values.
  rct : TRect;                   //Rectangle used to draw frame around button
  offset : Integer;              //Used for Caption location during Mouse Down
  bm     : TBitMap;

  {To speed things up and reduce flicker, I use a Bitmap to draw the button in
 its entirety, ten BitBlt it to the canvas of the control.}
procedure DoHorizontal(fr, fg, fb, dr, dg, db : Integer);
var
  ColorRect: TRect;
  I: Integer;
  R, G, B : Byte;
begin
  ColorRect.Top:= 0;                //Set rectangle top
  ColorRect.Bottom := bm.Height;
  for I := 0 to 255 do begin         //Make lines (rectangles) of color
    ColorRect.Left:= MulDiv (I, bm.Width, 256);    //Find left for this color
    ColorRect.Right:= MulDiv (I + 1, bm.Width, 256);   //Find Right
    R := fr + MulDiv(I, dr, 255);    //Find the RGB values
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
    bm.Canvas.Brush.Color := RGB(R, G, B);   //Plug colors into brush
    bm.Canvas.FillRect(ColorRect);           //Draw on Bitmap
  end;
end;

procedure DoVertical(fr, fg, fb, dr, dg, db : Integer);
var
  ColorRect: TRect;
  I: Integer;
  R, G, B : Byte;
begin
  ColorRect.Left:= 0;                //Set rectangle left&right
  ColorRect.Right:= bm.Width;
  for I := 0 to 255 do begin         //Make lines (rectangles) of color
    ColorRect.Top:= MulDiv (I, bm.Height, 256);    //Find top for this color
    ColorRect.Bottom:= MulDiv (I + 1, bm.Height, 256);   //Find Bottom
    R := fr + MulDiv(I, dr, 255);    //Find the RGB values
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
    bm.Canvas.Brush.Color := RGB(R, G, B);   //Plug colors into brush
    bm.Canvas.FillRect(ColorRect);           //Draw on Bitmap
  end;
end;

procedure DoElliptic(fr, fg, fb, dr, dg, db : Integer);
var
  I: Integer;
  R, G, B : Byte;
  Pw, Ph : Real;
  x1,y1,x2,y2 : Real;
{The elliptic is a bit different, since I had to use real numbers. I cut down
 on the number (to 155 instead of 255) of iterations in an attempt to speed
 things up, to no avail.  I think it just takes longer for windows to draw an
 ellipse as opposed to a rectangle.}
begin
  bm.Canvas.Pen.Style := psClear;
  bm.Canvas.Pen.Mode := pmCopy;
  x1 := 0 - (bm.Width / 4);
  x2 := bm.Width + (bm.Width / 4);
  y1 := 0 - (bm.Height / 4);
  y2 := bm.Height + (bm.Height / 4);
  Pw := ((bm.Width / 4) + (bm.Width / 2)) / 155;
  Ph := ((bm.Height / 4) + (bm.Height / 2)) / 155;
  for I := 0 to 155 do begin         //Make ellipses of color
    x1 := x1 + Pw;
    x2 := X2 - Pw;
    y1 := y1 + Ph;
    y2 := y2 - Ph;
    R := fr + MulDiv(I, dr, 155);    //Find the RGB values
    G := fg + MulDiv(I, dg, 155);
    B := fb + MulDiv(I, db, 155);
    bm.Canvas.Brush.Color := R or (G shl 8) or (b shl 16);   //Plug colors into brush
    bm.Canvas.Ellipse(Trunc(x1),Trunc(y1),Trunc(x2),Trunc(y2));
  end;
  bm.Canvas.Pen.Style := psSolid;
end;

procedure DoRectangle(fr, fg, fb, dr, dg, db : Integer);
var
  I: Integer;
  R, G, B : Byte;
  Pw, Ph : Real;
  x1,y1,x2,y2 : Real;
begin
  bm.Canvas.Pen.Style := psClear;
  bm.Canvas.Pen.Mode := pmCopy;
  x1 := 0;
  x2 := bm.Width;
  y1 := 0;
  y2 := bm.Height;
  Pw := (bm.Width / 2) / 255;
  Ph := (bm.Height / 2) / 255;
  for I := 0 to 255 do begin         //Make rectangles of color
    x1 := x1 + Pw;
    x2 := X2 - Pw;
    y1 := y1 + Ph;
    y2 := y2 - Ph;
    R := fr + MulDiv(I, dr, 255);    //Find the RGB values
    G := fg + MulDiv(I, dg, 255);
    B := fb + MulDiv(I, db, 255);
    bm.Canvas.Brush.Color := RGB(R, G, B);   //Plug colors into brush
    bm.Canvas.FillRect(Rect(Trunc(x1),Trunc(y1),Trunc(x2),Trunc(y2)));
  end;
  bm.Canvas.Pen.Style := psSolid;
end;

procedure DoVertCenter(fr, fg, fb, dr, dg, db : Integer);
var
  ColorRect: TRect;
  I: Integer;
  R, G, B : Byte;
  Haf : Integer;
begin
  Haf := bm.Height Div 2;
  ColorRect.Left := 0;
  ColorRect.Right := bm.Width;
  for I := 0 to Haf do begin
    ColorRect.Top := MulDiv (I, Haf, Haf);
    ColorRect.Bottom := MulDiv (I + 1, Haf, Haf);
    R := fr + MulDiv(I, dr, Haf);
    G := fg + MulDiv(I, dg, Haf);
    B := fb + MulDiv(I, db, Haf);
    bm.Canvas.Brush.Color := RGB(R, G, B);
    bm.Canvas.FillRect(ColorRect);
    ColorRect.Top := bm.Height - (MulDiv (I, Haf, Haf));
    ColorRect.Bottom := bm.Height - (MulDiv (I + 1, Haf, Haf));
    bm.Canvas.FillRect(ColorRect);
  end;
end;

procedure DoHorizCenter(fr, fg, fb, dr, dg, db : Integer);
var
  ColorRect: TRect;
  I: Integer;
  R, G, B : Byte;
  Haf : Integer;
begin
  Haf := bm.Width Div 2;
  ColorRect.Top := 0;
  ColorRect.Bottom := bm.Height;
  for I := 0 to Haf do begin
    ColorRect.Left := MulDiv (I, Haf, Haf);
    ColorRect.Right := MulDiv (I + 1, Haf, Haf);
    R := fr + MulDiv(I, dr, Haf);
    G := fg + MulDiv(I, dg, Haf);
    B := fb + MulDiv(I, db, Haf);
    bm.Canvas.Brush.Color := RGB(R, G, B);
    bm.Canvas.FillRect(ColorRect);
    ColorRect.Left := bm.Width - (MulDiv (I, Haf, Haf));
    ColorRect.Right := bm.Width - (MulDiv (I + 1, Haf, Haf));
    bm.Canvas.FillRect(ColorRect);
  end;
end;

begin
 Try
  bm:=TBitMap.Create;
  if Cv = NIL then Exit;
  bm.Width := X1-X;          //Set BMP dimensions to match control's
  bm.Height :=Y1-Y;
  rct :=Rect(0,0,bm.Width,bm.Height);  //Set rectangle size for later use
  FromR := FBeginClr and $000000ff;  //Strip out separate RGB values
  FromG := (FBeginClr shr 8) and $000000ff;
  FromB := (FBeginClr shr 16) and $000000ff;
  DiffR := (FEndClr and $000000ff) - FromR;   //Find the difference
  DiffG := ((FEndClr shr 8) and $000000ff) - FromG;
  DiffB := ((FEndClr shr 16) and $000000ff) - FromB;
  //Depending on gradient style selected, go draw it on the Bitmap canvas.
  if FGradientStyle = gsHorizontal then
    DoHorizontal(FromR, FromG, FromB, DiffR, DiffG, DiffB);
  if FGradientStyle = gsVertical then
    DoVertical(FromR, FromG, FromB, DiffR, DiffG, DiffB);
  if FGradientStyle = gsElliptic then
    DoElliptic(FromR, FromG, FromB, DiffR, DiffG, DiffB);
  if FGradientStyle = gsRectangle then
    DoRectangle(FromR, FromG, FromB, DiffR, DiffG, DiffB);
  if FGradientStyle = gsVertCenter then
    DoVertCenter(FromR, FromG, FromB, DiffR, DiffG, DiffB);
  if FGradientStyle = gsHorizCenter then
    DoHorizCenter(FromR, FromG, FromB, DiffR, DiffG, DiffB);
  //By setting the Brush style to Clear, it will draw without overlaying bkgrnd
  bm.Canvas.Brush.Style := bsClear;  //Gradient is done, time for Hilite-Shadow
  {Finally, the button is all painted on the bitmap canvas.  Now we just need
   to copy it to the canvas of our control.  BitBlt is one method; there are
   several others.}
  BitBlt(Cv.Handle,X,Y,bm.Width,bm.Height,bm.Canvas.Handle,0,0,SRCCOPY);
 finally
  bm.Free;
 end;
end;

(****************************************************)

procedure TRoundRectForm.Button5Click(Sender: TObject);
begin
  VarForm := TVarForm.Create(nil);
  with VarForm do
  if ShowModal = mrOk then
  begin
    ClipBoard.Clear;
    if Variables.ItemIndex >= 0 then
      ClipBoard.AsText := '[' + Variables.Items[Variables.ItemIndex] + ']';
    M1.PasteFromClipboard;
  end;
  VarForm.Free;
  M1.SetFocus;
end;

procedure TRoundRectForm.Button6Click(Sender: TObject);
begin
  FieldsForm := TFieldsForm.Create(nil);
  with FieldsForm do
  if ShowModal = mrOk then
  begin
    ClipBoard.Clear;
    ClipBoard.AsText := '[' + DBField + ']';
    M1.PasteFromClipboard;
  end;
  FieldsForm.Free;
  M1.SetFocus;
end;

procedure TRoundRectForm.ChgColorButton(S : TObject;C : TColor);
Var BM : TBitMap;
    Bc : TImage;
Begin
  Try
    BM:=TBitMap.Create;
    Bc:=S as TImage;
    BM.Height:=bC.Height;
    BM.Width :=bC.Width;

    With BM.Canvas do
    begin
      Pen.Color:=clBlack;
      Brush.Color:=C;
      Rectangle(0,0,bC.Width,bC.Height);
    end;
  finally
    If Bc.Tag=0 then ShadowColor:=C
                else NormalColor:=C;
                
    bC.Picture.Assign(BM);
    BM.Free;
  end;
end;

procedure TRoundRectForm.UpdateSample;
Var CC  : TCanvas;
    FsW : Integer;
    FCu : Integer;
    BM  : TBitMap;
Begin
 Try

   Try
    FsW:=StrToInt(ShWidth.Text);
   Except
    FsW:=10;
   end;

   Try
    FCu:=StrToInt(SCurve.Text);
   Except
    FCu:=10;
   end;

   BM:=TBitMap.Create;
   BM.Height:=imgSample.Height;
   BM.Width :=imgSample.Width;

   CC:=BM.Canvas;

   If cbGradian.Checked then
   Begin
     FsW:=cbStyle.ItemIndex;
     if FsW<0 then FsW:=0;
     PaintGrad(CC,0,0,bm.Width,bm.Height,NormalColor,ShadowColor,TGradientStyle(FsW));
     exit;
   end;

   // Rinitialise le panel
   CC.Pen.Color:=clBtnFace;
   CC.Brush.Color:=clBtnFace;
   CC.Rectangle(0,0,imgSample.Width,imgSample.Height);

   // Trace l'ombre
   CC.Pen.Color:=ShadowColor;
   CC.Brush.Color:=ShadowColor;

   if cmShadow.Checked then
      CC.RoundRect(0+FSW,0+FSW,imgSample.Width,imgSample.Height,FCu,Fcu) //,FCu)
     else
      CC.Rectangle(0+FSW,0+FSW,imgSample.Width,imgSample.Height);

   // Trace la zone de texte
   if not cbCadre.Checked then
     CC.Pen.Color:=NormalColor
   else
     CC.Pen.Color:=clBlack; // Trace le cadre

   CC.Brush.Color:=NormalColor;
   if cmShadow.Checked then
      CC.RoundRect(0,0,imgSample.Width-FSW,imgSample.Height-FSW,FCu,Fcu) //,FCu)
     else
      CC.Rectangle(0,0,imgSample.Width-FSW,imgSample.Height-FSW);
 finally
   imgSample.Picture.Assign(BM);
   BM.Free;
 end;
End;

procedure TRoundRectForm.bColorClick(Sender: TObject);
begin
  ColorDlg.Color:=ShadowColor;
  if ColorDlg.Execute then
  begin
    ChgColorButton(Sender,ColorDlg.Color);
    UpdateSample;
  end;
end;

procedure TRoundRectForm.ShWidthChange(Sender: TObject);
begin
 If Sender is TEdit then
  If TEdit(Sender).Text='' then Exit;
  UpdateSample;
end;

procedure TRoundRectForm.FormCreate(Sender: TObject);
begin
  ShadowColor:=clGray;
  NormalColor:=clWhite;
  panGrad.left:=panCurve.Left;
  panGrad.Top :=panCurve.Top;
  panGrad.visible:=False;
  UpdateSample;
end;

procedure TRoundRectForm.cbCadreClick(Sender: TObject);
begin
  UpdateSample;
end;

procedure TRoundRectForm.cmShadowClick(Sender: TObject);
begin
  UpdateSample;
end;

procedure TRoundRectForm.FormActivate(Sender: TObject);
begin
  M1.SetFocus;
  UpdateSample;
  ChgColorButton(bColor,ShadowColor);
  ChgColorButton(bColor2,NormalColor);
  ChgColorButton(bColor3,ShadowColor);
end;

procedure TRoundRectForm.M1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = vk_Insert) and (Shift = []) then Button5Click(Self);
  if Key = vk_Escape then ModalResult := mrCancel;
end;

procedure TRoundRectForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (Key = vk_Return) and (ssCtrl in Shift) then
  begin
    ModalResult := mrOk;
    Key := 0;
  end;
end;

procedure TRoundRectForm.ShowEditor(t:TfrView);
begin
  M1.Lines.Assign(t.Memo);
  with t as TfrRoundRectView do
  begin
    shWidth.Text:=IntToStr(Cadre.wShadow);
    if Cadre.wShadow<>-99 then
    Begin
      cbGradian.Checked:=False;
      ShadowColor:=Cadre.sdColor;
      NormalColor:=FillColor;
      cbCadre.Checked :=Cadre.Cadre;
      cmShadow.Checked:=Cadre.sCurve;
      sCurve.Text:=IntToStr(Cadre.wCurve);
    end
    else
    Begin
      cbGradian.Checked:=True;
      ShadowColor:=Cadre.sdColor;
      NormalColor:=FillColor;
      if Cadre.wCurve>cbStyle.Items.Count-1 then Cadre.wCurve:=0;
      cbStyle.ItemIndex:=Cadre.wCurve;
    end;


    if ShowModal = mrOk then
    begin
      Memo.Assign(M1.Lines);
      Cadre.sdColor:=ShadowColor;
      FillColor    :=NormalColor;
      Cadre.sCurve :=cmShadow.Checked;
      Cadre.Cadre  :=cbCadre.Checked;
      Try
       Cadre.wShadow:=StrToInt(shWidth.Text);
      except
       Cadre.wShadow:=6;
      end;

      Try
       Cadre.wCurve:=StrToInt(sCurve.Text);
       if Cadre.wShadow=-99 then
        Cadre.wCurve:=cbStyle.ItemIndex;
      except
       Cadre.wCurve:=10;
      end;
    end;
  end;
end;

(********************************************************)
constructor TfrRoundRectView.Create;
begin
  inherited Create;

  // Valeurs par defauts
  Cadre.SdColor:=clGray;
  Cadre.wShadow:=6;
  Cadre.Cadre:=True;
  Cadre.sCurve:=True;
  Cadre.wCurve:=10;

  // Mots entiers par defaut
  Flags:=flWordWrap;
  Typ  :=gtMemo;
end;

procedure TfrRoundRectView.Assign(From:TfrView);
begin
  inherited Assign(From);
  Cadre := (From as TfrRoundRectView).Cadre;
end;

procedure TfrRoundRectView.LoadFromStream(Stream:TStream);
begin
  inherited LoadFromStream(Stream);
  Stream.Read(Cadre,SizeOf(Cadre));
end;

procedure TfrRoundRectView.SaveToStream(Stream:TStream);
begin
  inherited SaveToStream(Stream);
  Stream.Write(Cadre,SizeOf(Cadre));
end;

procedure TfrRoundRectView.CalcGaps;
begin
  inherited CalcGaps;

  // Zone de text (MEMO)
  Drect.Left:=DRect.Left+(Cadre.wCurve div 4);
  DRect.Top :=DRect.Top+(Cadre.wCurve div 4);
  DRect.Right:=DRect.Right-((Cadre.wShadow+Cadre.wCurve) div 4);
  DRect.Bottom:=DRect.Bottom-((Cadre.wShadow+Cadre.wCurve) div 4);
  // Position de dbut haut  gauche}
  gapx:=gapx+(Cadre.wCurve div 4);
  gapy:=gapy+(Cadre.wCurve div 4);
end;

procedure TfrRoundRectView.ShowBackGround;
Begin
 // ne fait rien
end;

procedure TfrRoundRectView.ShowFrame;
Var FSW,FCU : Integer;

procedure Line(x,y,dx,dy:Integer);
begin
  Canvas.MoveTo(x,y);
  Canvas.LineTo(x+dx,y+dy);
end;

procedure FrameLine(i: Integer);
begin
  Canvas.Pen.Width := FrameWidth;
  case i of
    0: Line(x+dx,y,0,dy);
    1: Line(x,y,0,dy);
    2: Line(x,y+dy,dx,0);
    3: Line(x,y,dx,0);
  end;
end;

begin
  if DisableDrawing then Exit;
//  if (DocMode = dmPrinting) and ((FrameTyp and $F) = 0) then Exit;
  with Canvas do
  begin

   if Cadre.wShadow=-99 then
   Begin
     if Cadre.wCurve<0 then Cadre.wCurve:=0;
     PaintGrad(Canvas,X,Y,X+DX,Y+DY,FillColor,Cadre.SdColor,TGradientStyle(Cadre.wCurve));
     Pen.Width :=FrameWidth;
     Pen.Color :=FrameColor;

     if (FrameTyp and $1) <> 0 then FrameLine(0);
     if (FrameTyp and $4) <> 0 then FrameLine(1);
     if (FrameTyp and $2) <> 0 then FrameLine(2);
     if (FrameTyp and $8) <> 0 then FrameLine(3);

     exit;
   end;

   // Trace l'ombre
   Pen.Style := psSolid;
   Brush.Style :=bsClear;
   Pen.Color:=Cadre.SdColor;
   Pen.Width:=FrameWidth;
   Brush.Color:=Cadre.SdColor;

   FSW :=Cadre.wShadow;
   FCU :=Cadre.wCurve;

   if Cadre.sCurve then
      RoundRect(x+FSW,y+FSW,x+dx+1,y+dy+1,FCu,Fcu)
     else
      Rectangle(x+FSW,y+FSW,x+dx+1,y+dy+1);

   // Trace la zone de texte
   Pen.Width :=FrameWidth;
   Cadre.Cadre:=((FrameTyp and $F) = $F); // Si zone de cadre dsactive

   if not Cadre.Cadre then
     Pen.Color:=FillColor
   else
     Pen.Color:=FrameColor; // Trace le cadre

     Brush.Color:=FillColor;
     if Cadre.sCurve then
       RoundRect(x,y,x+dx+1-FSW,y+dy+1-FSW,FCu,Fcu)
      else
       Rectangle(x,y,x+dx+1-FSW,y+dy+1-FSW);
  end;
end;

Procedure Register;
begin
RegisterComponents('FastReport',[TfrRoundRectObject]);
end;

procedure TRoundRectForm.cbGradianClick(Sender: TObject);
begin
  panGrad.Visible:=cbGradian.Checked;
  panCurve.Visible:=Not panGrad.Visible;
  if panGrad.Visible then
  begin
   shWidth.text:='-99';
   sCurve.Text :='0';
   cbStyle.ItemIndex:=0;
  end
  else
  Begin
    shWidth.Text:='10';
    sCurve.Text :='10';
  end;

end;

initialization
  RoundRectForm:= TRoundRectForm.Create(nil);
  frRegisterObject(TfrRoundRectView,RoundRectForm.Image1.Picture.Bitmap,
    frLoadStr('sRoundRectMemo'),RoundRectForm);

finalization
  RoundRectForm.Free;
end.
